/* COOL Works App Framework header */
#ifndef CW_HEADER
#define APPDIR  101
#define SRCDIR  102
#define DEMOOPT 103
#define HELPOPT 104
#define SRCOPT  105
#define MSCOPT  106
#define CW_HEADER
#ifdef __cplusplus
extern "C" {
#endif

/*********************/
/*     Data types    */
typedef struct
                                {
                                int id;
                                WORD typelen;
                                LPSTR value;
        } DLGITEMS, FAR *LPDLGITEMS;


/*********************/
/* General functions */
BOOL WINAPI cw_Begin(HANDLE hInst);
BOOL WINAPI cw_BeginIcons(HANDLE,HICON,HICON,HICON);
void WINAPI cw_End(HANDLE hInst);
LONG WINAPI cw_CoolWorxVersion(void);
BOOL WINAPI cw_ModelessRegister(HWND,BOOL);
BOOL WINAPI cw_DialogProcess(LPMSG);
WORD WINAPI cw_Run(HWND w,HWND mdi,int nracc,LPHANDLE ary,
        BOOL idle,BOOL help);
void WINAPI cw_SetIcon(HWND w,HICON ico); /*Set for class*/
#define CW_MESSAGE (WM_USER+2000)


/*********************/
/* Ribbon functions */
HWND WINAPI cw_Ribbon(LPCSTR id,HWND par,
       LONG param);
void WINAPI cw_SetRibbon(HWND,UINT id,LPCSTR s);
BOOL WINAPI cw_RibbonAdj(HWND,LPRECT );
BOOL WINAPI cw_RibbonInvAdj(HWND w,LPRECT r,BOOL vis,HWND stop);
void WINAPI cw_GetClientRect(HWND,LPRECT);
HWND WINAPI cw_GetRibbon(HWND w,LONG param);
void WINAPI cw_EnableCommand(HMENU m,HWND w,
  int cmd,BOOL f,BOOL vis);
#define CWRIBBON_TOP 0
#define CWRIBBON_BOTTOM 1
#define CWRIBBON_RIGHT 2
#define CWRIBBON_LEFT 3
#define CWRIBBON_FOCUSOK 0x80000000L

/*********************/
/*    SDI support    */
HWND WINAPI cw_SDICreate(LPCSTR title,LPCSTR menu,
   HANDLE hInst,FARPROC cb,LPCSTR top,LPCSTR left,LPCSTR right,
   LPCSTR bot,LONG lParam);
LONG WINAPI cw_DefWindowProc(HWND,UINT,UINT,LONG);


/*********************/
/*   MDI support    */
LONG WINAPI cw_DefFrameProc(HWND w,WORD msg,WPARAM wParam,
  LPARAM lParam);
LONG WINAPI cw_DefMDIChildProc(HWND w,WORD msg,WPARAM wParam,
        LPARAM lParam);
HWND WINAPI cw_MDISetFrame(HWND frame,HWND client,
  int winmenuoff,BOOL scroll,int id1,HANDLE acc,HWND toolbar);
HWND WINAPI cw_MDICreateChild(LPCSTR cls,LPCSTR nam,DWORD sty,
  int x,int y,int wid,int hi,LPCSTR m,HWND parent,
  HANDLE hinst,int winmen,HACCEL acc,LPCSTR toolbar,
  LONG tbwhere,DWORD lParam);
HWND WINAPI cw_MDICreateFrame(LPCSTR title,LPCSTR menu,int winmen,
    HANDLE hinst,FARPROC cb,BOOL scroll,
    int id1,LPCSTR topbar,LPCSTR leftbar,LPCSTR rightbar,
    LPCSTR botbar,HACCEL acc, LONG wheretool,LONG lParam);
HWND WINAPI cw_MDIGetActive(HWND w);
LONG WINAPI cw_MDISendActive(HWND w,WORD msg,WPARAM wParam,
   DWORD lParam);
void WINAPI cw_MDIShowRibbon(HWND rib,BOOL show);
void WINAPI cw_MDIShowToolBar(HWND rib,LONG where,BOOL show);
HWND WINAPI cw_MDIGetClientWindow(HWND);
#define CW_MDICREATE (CW_MESSAGE+0)
#define CW_SDICREATE (CW_MESSAGE+0)
/* Private message */
#define CW_MDICLDMENU (CW_MESSAGE+2)

/*********************/
/*  Editor support  */
BOOL WINAPI cw_EditOpenFile(HWND w,LONG styles,LPCSTR menuid,
   int winmenu,LPCSTR fn,int siz,HACCEL acc,LPCSTR tb,LONG tbw);
BOOL WINAPI cw_EditOpenFileName(HWND w,LONG styles,LPCSTR menuid,
   int winmenu,LPCSTR fbuf,BOOL ro,HACCEL acc,LPCSTR tb,LONG tbw);
BOOL WINAPI cw_EditSaveFile(HWND w,LPCSTR filename);
BOOL WINAPI cw_EditPrint(HWND w);
void WINAPI cw_EditSetFont(HWND w,LPLOGFONT lfp);
void WINAPI cw_EditStatus(HWND w,LONG where,HWND ed,int id,
  BOOL force);
BOOL WINAPI cw_EditSDIOpenFile(HWND w,LPCSTR f,int siz);
void WINAPI cw_EditSDINew(HWND w);
BOOL WINAPI cw_EditOpen(HWND ed,LPCSTR fn,BOOL ro);
void WINAPI cw_EditGetSel(HWND w,LPSTR bf,int sz);
void WINAPI cw_EditFreePtr(LPCSTR p);
LPCSTR WINAPI cw_EditGetPtr(HWND cwed);
BOOL WINAPI cw_EditFind(HWND cwed,LPCSTR s,DWORD flag);
int WINAPI cw_EditRepl(HWND cwed,LPCSTR s,LPCSTR r,DWORD flag);
/* Editor styles */
#define CE_HSCROLL 8
#define CE_VSCROLL 16

/**********************/
/* INI file functions */
void WINAPI cw_IniOpenMenu(LPCSTR f,HMENU men,
   int index,int pos,int id);
void WINAPI cw_IniOpenSet(LPCSTR inifile,LPCSTR fn);
void WINAPI cw_IniOpenSetNum(LPCSTR inifile,int n);
void WINAPI cw_IniOpenGet(LPCSTR inifile,int base,
        int id,LPCSTR fn,int siz);
void WINAPI cw_IniPosSave(LPCSTR fn,LPCSTR key,HWND w);
void WINAPI cw_IniPosSet(LPCSTR fn,LPCSTR key,HWND w);

/**********************/
/*  Timer functions  */
BOOL WINAPI cw_UseTimer(HWND w,BOOL f);
#define CW_TIMER (CW_MESSAGE+3)
#define CW_IDLE (CW_MESSAGE+5)

/**********************/
/* Status bar support*/
void WINAPI cw_StatusKeys(HWND w,LONG where,
        int cap,int num,int ins,int scr);
void WINAPI cw_ToggleKeyState(int key);
void WINAPI cw_StatusTime(HWND w,LONG where,int id);

/*********************/
/*    Help system    */
void WINAPI cw_StatusHelp(HANDLE,HWND,UINT,UINT);
#define CW_HELPID (CW_MESSAGE+6)
#define CW_COMMDLGHELP (CW_MESSAGE+7)

/*********************/
/*   Dialog system   */

LONG WINAPI cw_CommDlgID(HWND w);
void WINAPI cw_DlgTransfer(HWND dlg, BOOL dir);
void WINAPI cw_EndDialog(HWND dlg,int result,BOOL xfer);
BOOL WINAPI cw_DlgSetItem(DLGITEMS FAR *items,int id,
        unsigned tl,LPSTR val);
HWND WINAPI cw_CreateDialogIndirectParam(HANDLE hInst,
        const void FAR *tname,HWND parent,DLGPROC cb,
        LPARAM lParam,DLGITEMS FAR *items);
HWND WINAPI cw_CreateDialogParam(HANDLE hInst,LPCSTR tname,
        HWND parent,DLGPROC cb,LPARAM lParam,DLGITEMS FAR *items);
#define cw_CreateDialog(a,b,c,d,e) \
                cw_CreateDialogParam(a,b,c,d,0,e)
#define cw_CreateDialogIndirect(a,b,c,d,e) \
                cw_CreateDialogIndirectParam(a,b,c,d,0,e)
int WINAPI cw_DialogBoxParam(HANDLE hInst,LPCSTR tname,HWND parent,
                                DLGPROC cb,LPARAM lParam,DLGITEMS FAR *items);
int WINAPI cw_DialogBoxIndirectParam(HANDLE hInst,HANDLE temp,HWND parent,
                                DLGPROC cb,LPARAM lParam,DLGITEMS FAR *items);
LPDLGITEMS WINAPI cw_NullCDlgTemp(void);
HWND WINAPI cw_ProgressDlg(HWND parent,LPCSTR title,LPCSTR text,DWORD max,BOOL cancel);
BOOL WINAPI cw_ProgressCancel(HWND dlg);
BOOL WINAPI cw_ProgressSet(HWND dlg,DWORD amt,LPCSTR text);
void WINAPI cw_ProgressReset(HWND dlg);

#define cw_DialogBox(a,b,c,d,e) \
        cw_DialogBoxParam(a,b,c,d,0,e)
#define cw_DialogBoxIndirect(a,b,c,d,e) \
        cw_DialogBoxIndirectParam(a,b,c,d,0,e)

#define DLGDATA(nam) DLGITEMS nam[]= {
#define DLGITEM(id,tl,buf) {id,tl,buf},
#define DLGEND {0,0,NULL} }

/* Radio/Check box */
#define CWDLG_BUTTON 0
/* Numeric combo box */
#define CWDLG_COMBOBOX 1
/* Text list box */
#define CWDLG_LISTBOX 2
/* Numeric listbox */
#define CWDLG_LB 3
/* Init listbox */
#define CWDLG_LBINIT 4
/* Init combo box */
#define CWDLG_CBINIT 5
/* Buttons */
#define CWDLG_PBUTTON 6
#define CWDLG_PBUTTONX 7
/* Multiselect LB */
#define CWDLG_MULTILB 8

/* tl>5 is string (static, edit, combo box) */

/* Common dialog identifications */
#define COMMON_OPEN 1
#define COMMON_SAVE 2
#define COMMON_FIND 3
#define COMMON_REPL 4
#define COMMON_PRINT 5
#define COMMON_FONT 6
#define COMMON_PSETUP 7
#define COMMON_COLOR 8


/*********************/
/*       Misc.       */

HBITMAP WINAPI cw_LogoBestBitmap(HANDLE hInst,UINT st,UINT end);
HWND WINAPI cw_Logo(HANDLE hInst,UINT st,UINT end,UINT dly,BOOL key,BOOL block);
BOOL WINAPI cw_GetFilename(HWND w,LPCSTR filename,int flen,LPCSTR title,int len,
                int how,LPCSTR filter,BOOL FAR *ro,BOOL usehelp);
/* Style for windows that can be MDI children
         (edit) */
#define CW_MDIWIN 1
#define CW_USEHELP 2
#define CW_USEPROG 4
/* Message for window that can init toolbars */
#define CW_INITTOOL (CW_MESSAGE+4)


/**********************/
/*    Menu defines   */
#define CW_STDMENU (CW_MESSAGE+1)
#include "cwmenu.h"

#ifdef __cplusplus
}
#endif

#endif

